@Echo Off

::
Set Dat=2020-09-28 13:27
::

	Title %~n0 (%Dat%)
	CD /d "%~dp0"
	Echo:"%CD%"|Find /c:" " >Nul 2>Nul
	If "%ErrorLevel%" == "0" (
		Echo:[0;101;93m One or more blanks found in: %CD%   Installation cancelled! [0m
	    Goto Done
	)
	Set FN=%~nx0
	If "%~1" == "" Goto AdminCheck
	Set CO1=%~1
	If "%CO1:~0,1% " NEQ "! " Echo:"/image:%~1">%~n0.ini

:AdminCheck
	Net Session >Nul 2>Nul
	If "%ErrorLevel%" NEQ "0" (
		PowerShell "saps -filepath '%FN%' -verb runas" >Nul 2>&1
	    Exit /b
	    Goto :EoF
	)

	Echo:"%*"|Find "!!" >Nul 2>Nul
	If "%ErrorLevel%" NEQ "0" (
		Start "" /Max "%FN%" %* !!
	    Goto :EoF
	)

	Set InstallLocation=/online
	If /i "%SystemDrive%" == "X:" (
		For %%a In (c d e f g h i j k l m n o p q r s t u v w y z) Do If Exist %%a:\Windows\Setup\State\State.ini Set InstallLocation=/image:%%a:\
	)

	If /i "%SystemDrive%" == "X:" If /i "%InstallLocation%" == "/online" Echo:[0;101;93m Could not find Windows installation! Process cancelled! [0m && Set /a Fail+=1 && Goto Done

	If /i "%SystemDrive%" NEQ "X:" If Exist "%~n0.ini" Set /p InstallLocation=<%~n0.ini

	If Exist "*.msixbundle" (
		Call :Install
	    Goto Done
	)
	If Exist "*.appxbundle" (
		Call :Install
	    Goto Done
	)
	If Exist "*.msix" (
		Call :Install
	    Goto Done
	)
	If Exist "*.appx" (
		Call :Install
	    Goto Done
	)
	If Exist "*.zip" (
		For /f %%a In ('Dir /a-d /b *.zip 2^>Nul') Do Call :ZipInstall "%%a"
	    Goto Done
	)
	For /f %%a In ('Dir /ad /b 2^>Nul ^|Find /i /v "_Ablage_" 2^>Nul') Do Call :DirCheck "%%a"
    Goto Done


:Done
	Echo:
	CD /d "%~dp0"
	If Exist %~n0.ini Del /f /q "%~n0.ini" >Nul 2>Nul
	If Exist Tmp\. RD /s /q Tmp
	If "%~2" == "EXIT" Goto :EoF
	Set FailText=
	If "%Fail%" NEQ "" If "%Fail%" NEQ "1" Set FailText=s
	If "%Fail%" == "" (
		Echo:[0;102;30m All installations were successful! [0m
	) Else (
		Echo:[0;101;93m %Fail% installation%FailText% failed! [0m
	)
	Echo:
	Set Tx=
	Set /p Tx=[0;93mExit with ENTER:[0m 
	Exit
    Goto :EoF


:Dependencies
	Set Arc=
	Echo:%1|Find /i "x86" >Nul 2>Nul
	If "%ErrorLevel%" == "0" Set Arc=x86
	Echo:%1|Find /i "x64" >Nul 2>Nul
	If "%ErrorLevel%" == "0" Set Arc=x64
	If "%Arc%" == "" Goto :EoF
	Set Dependencies=%Dependencies%/DependencyPackagePath:%1 
	Echo:Dependency : %1
    Goto :EoF


:DirCheck
	Copy /y "%~nx0" "%~1" >Nul 2>Nul
	CD "%~1"
		Call "%~nx0" !! EXIT
	CD..
    Goto :EoF


:Install
	Set Dependencies=
	Set LicensePath=
	Set PackagePath=
	Echo:"%CD%"|Find /c:" " >Nul 2>Nul
	If "%ErrorLevel%" == "0" Echo:[0;101;93m One or more blanks found in: %CD%   Installation cancelled! [0m && Goto :EoF

	For /f "tokens=*" %%a In ('Dir /b *.msix* 2^>Nul^|Find /i /v "Framework"^|Find /i /v "Microsoft.UI.Xaml"^|Find /i /v "runtime"^|Find /i /v "VCLibs"^|Find /i /v ".zip"') Do Set PackagePath=/PackagePath:"%%a"
	If "%PackagePath%" == "" For /f "tokens=*" %%a In ('Dir /b *.appx* 2^>Nul^|Find /i /v "Framework"^|Find /i /v "Microsoft.UI.Xaml"^|Find /i /v "runtime"^|Find /i /v "VCLibs"^|Find /i /v ".zip"') Do Set PackagePath=/PackagePath:"%%a"
	If "%PackagePath%" == "" Echo:[0;101;93m Neither appx or appxbundle nor msix or msixbundle found! [0m && Set /a Fail+=1 && Goto Done
	Echo:PackagePath: %PackagePath%
	For /f "tokens=*" %%a In ('Dir /b *.xml 2^>Nul^') Do Set LicensePath=/LicensePath:"%%a"
	If "%LicensePath%" == "" Echo:[0;101;93m Licensefile not found! [0m && Set /a Fail+=1 && Goto Done
	Echo:LicensePath: %LicensePath%
	For /f "tokens=*" %%a In ('Dir /b *.appx* 2^>Nul^|Find /i "Framework"') Do Call :Dependencies "%%a"
	For /f "tokens=*" %%a In ('Dir /b *.appx* 2^>Nul^|Find /i "Microsoft.UI.Xaml"') Do Call :Dependencies "%%a"
	For /f "tokens=*" %%a In ('Dir /b *.appx* 2^>Nul^|Find /i "runtime"') Do Call :Dependencies "%%a"
	For /f "tokens=*" %%a In ('Dir /b *.appx* 2^>Nul^|Find /i "Microsoft.Services.Store.Engagement"') Do Call :Dependencies "%%a"
	For /f "tokens=*" %%a In ('Dir /b *.appx* 2^>Nul^|Find /i "VCLibs"') Do Call :Dependencies "%%a"
	
	Set Region="All"

:: ALDI-, MEDION-, Schufa-, ALDI-Foto, McAfee-UWP
	Call :RegionCheck "MEDION.AldiAngebote_eqf9tz77ft5w8!App" "DE"
	Call :RegionCheck "MEDION.AldiFoto_eqf9tz77ft5w8!App" "DE"
	Call :RegionCheck "MEDION.ALDIlife_eqf9tz77ft5w8!App" "DE"
	Call :RegionCheck "MEDION.AldiTalk_eqf9tz77ft5w8!App" DE
	Call :RegionCheck "MEDION.Internet-Security_eqf9tz77ft5w8!App" "DE"
	Call :RegionCheck "MEDION.MEDION_eqf9tz77ft5w8!App" "DE"
	Call :RegionCheck "SCHUFAHoldingAG.meineSCHUFAplus_tpk8v36tk93y2!App" "DE"
	Call :RegionCheck "MEDION.MEDIONASSISTENT_eqf9tz77ft5w8!App" "DE"

:: Alexa-UWP
:: Source for region-support: eMail Pawel W. 10.09.2019 10:36
	Type AUMIDs.txt|Find /i "57540AMZNMobileLLC.AmazonAlexa_22t9g3sebte08!App" >Nul 2>Nul
	If "%ErrorLevel%" == "0" Set Region="AT;AU;CA;DE;ES;FR;GB;IE;IN;IT;JP;NZ;US"
	Set InstCommand=Dism %InstallLocation:~% /Add-ProvisionedAppxPackage %PackagePath% %LicensePath% %Dependencies%/Region=%Region%
	Echo:
	Echo:%InstCommand%
	Echo:
	%InstCommand%
	Set ERL=%ErrorLevel%
	If "%ERL%" == "0" (
		Echo:[0;92mInstallation successful![0m
	) Else (
		Set /a Fail+=1
		Echo:[0;101;93m Installation FAILED with ErrorLevel %ERL%! [0m
	)
	Echo:
    Goto :EoF


:RegionCheck
	Type AUMIDs.txt|Find /i "%~1" >Nul 2>Nul
	If "%ErrorLevel%" NEQ "0" Goto :EoF
	Set Region="%~2"

:: McAfee-UWPs starting with 24.06.2020 are for all regions:        XXX        |----------------DE-version---------------|
	If "%~1" == "MEDION.Internet-Security_eqf9tz77ft5w8!App" If Not Exist "11fb842461f147578f595a2d06903004.appxbundle" Set Region="All"
	
    Goto :EoF


:ZipInstall
	Echo.[0;1;4m%~n1:[0m
	Echo:Expand-Archive "%~1" "%~n1"|PowerShell.exe -command -
	CD "%~n1"
		Call :Install
	CD..
	RD /s /q "%~n1"
    Goto :EoF
